image: docker:19.03.12

stages:
  - build
  - test
  - push

variables:
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""

services:
  - docker:19.03.12-dind

before_script:
  - echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY

'Build frontend container':
  stage: build
  script:
    - echo -n $DOCKERHUB_PASSWORD | docker login -u $DOCKERHUB_USERNAME --password-stdin
    - docker build --pull --no-cache --tag ${CI_REGISTRY_IMAGE}:frontend_staging . -f ./docker/frontend/Dockerfile
    # push
    - docker push ${CI_REGISTRY_IMAGE}:frontend_staging

'Build backend container':
  stage: build
  script:
    - echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY
    - echo -n $DOCKERHUB_PASSWORD | docker login -u $DOCKERHUB_USERNAME --password-stdin
    - docker build --pull --no-cache --tag ${CI_REGISTRY_IMAGE}:backend_staging . -f ./docker/backend/Dockerfile
    # push
    - docker push ${CI_REGISTRY_IMAGE}:backend_staging

'Test frontend':
  stage: test
  image: tiangolo/docker-with-compose
  script:
    - docker-compose -f docker-compose.test_frontend.yml up --exit-code-from cypress

'Test backend':
  stage: test
  image: tiangolo/docker-with-compose
  script:
    # lint
    - docker-compose -f docker-compose.test_backend.yml run backend flake8
    # test with coverage
    - docker-compose -f docker-compose.test_backend.yml run backend python run_coverage.py test

'Push containers for production use':
  stage: push
  variables:
    GIT_STRATEGY: none
  script:
    # pull staging
    - docker pull ${CI_REGISTRY_IMAGE}:frontend_staging
    - docker pull ${CI_REGISTRY_IMAGE}:backend_staging
    # tag latest
    - docker tag ${CI_REGISTRY_IMAGE}:frontend_staging ${CI_REGISTRY_IMAGE}:frontend
    - docker tag ${CI_REGISTRY_IMAGE}:backend_staging ${CI_REGISTRY_IMAGE}:backend
    # push
    - docker push ${CI_REGISTRY_IMAGE}:frontend
    - docker push ${CI_REGISTRY_IMAGE}:backend
  only:
    refs:
      - master
      - schedules